# This file was auto-generated by Fern from our API Definition.

import typing

import pydantic
from ..core.pydantic_utilities import IS_PYDANTIC_V2, UniversalBaseModel


class AgentWithFqn(UniversalBaseModel):
    name: typing.Optional[str] = pydantic.Field(default=None)
    """
    Name of the entity
    """

    description: typing.Optional[str] = None
    metadata: typing.Dict[str, typing.Optional[typing.Any]] = pydantic.Field()
    """
    Key value metadata. Should be valid JSON. For e.g. `{"business-unit": "sales", "quality": "good", "rating": 4.5}`
    """

    version_alias: typing.Optional[str] = pydantic.Field(default=None)
    """
    Version alias is alternate, ideally human readable, version string to reference an artifact version. It should start with `v` followed by alphanumeric and it can include `.` and `-` in between (e.g. `v1.0.0`, `v1-prod`, `v3-dev`, etc)
    """

    ml_repo: typing.Optional[str] = pydantic.Field(default=None)
    """
    Name of the ML Repo
    """

    version: typing.Optional[int] = pydantic.Field(default=None)
    """
    Version of the entity
    """

    type: typing.Literal["agent"] = pydantic.Field(default="agent")
    """
    Type of the entity
    """

    goal: str = pydantic.Field()
    """
    Short form description. Will be used as `description` when this agent is used as a tool.
    """

    instruction: str = pydantic.Field()
    """
    Instructions for the agent to follow to achieve the goal
    """

    available_tools: typing.List[str] = pydantic.Field()
    """
    Tools available to the agent
    """

    model_id: str = pydantic.Field()
    """
    Model to use when running the agent
    """

    id: str = pydantic.Field()
    """
    ID of the agent
    """

    fqn: str = pydantic.Field()
    """
    FQN of the agent
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow")  # type: ignore # Pydantic v2
    else:

        class Config:
            smart_union = True
            extra = pydantic.Extra.allow
