# This file was auto-generated by Fern from our API Definition.

import typing

import pydantic
from ..core.pydantic_utilities import IS_PYDANTIC_V2, UniversalBaseModel
from .notification_target import NotificationTarget
from .workflow_event import WorkflowEvent


class WorkflowAlert(UniversalBaseModel):
    """
    +docs=Describes the configuration for the workflow alerts
    +label=Alert
    """

    notification_target: typing.Optional[NotificationTarget] = None
    events: typing.Optional[typing.List[WorkflowEvent]] = pydantic.Field(default=None)
    """
    +label=Alert Events
    +usage=Specify the events to send alerts for, it should be one of the following: SUCCEEDED, FAILED, ABORTED, TIMED_OUT
    +sort=670
    +uiType=Hidden
    """

    on_completion: typing.Optional[bool] = pydantic.Field(default=None)
    """
    +label=On Completion
    +usage=Send an alert when the job completes
    +sort=680
    """

    on_failure: typing.Optional[bool] = pydantic.Field(default=None)
    """
    +label=On Failure
    +usage=Send an alert when the job fails
    +sort=690
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow")  # type: ignore # Pydantic v2
    else:

        class Config:
            smart_union = True
            extra = pydantic.Extra.allow
