# This file was auto-generated by Fern from our API Definition.

from ...core.client_wrapper import AsyncClientWrapper, SyncClientWrapper
from .applications.client import ApplicationsClient, AsyncApplicationsClient
from .artifact_versions.client import ArtifactVersionsClient, AsyncArtifactVersionsClient
from .clusters.client import AsyncClustersClient, ClustersClient
from .deployments.client import AsyncDeploymentsClient, DeploymentsClient
from .metrics.client import AsyncMetricsClient, MetricsClient
from .raw_client import AsyncRawInternalClient, RawInternalClient
from .users.client import AsyncUsersClient, UsersClient
from .vcs.client import AsyncVcsClient, VcsClient


class InternalClient:
    def __init__(self, *, client_wrapper: SyncClientWrapper):
        self._raw_client = RawInternalClient(client_wrapper=client_wrapper)
        self.users = UsersClient(client_wrapper=client_wrapper)

        self.clusters = ClustersClient(client_wrapper=client_wrapper)

        self.deployments = DeploymentsClient(client_wrapper=client_wrapper)

        self.applications = ApplicationsClient(client_wrapper=client_wrapper)

        self.vcs = VcsClient(client_wrapper=client_wrapper)

        self.metrics = MetricsClient(client_wrapper=client_wrapper)

        self.artifact_versions = ArtifactVersionsClient(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> RawInternalClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        RawInternalClient
        """
        return self._raw_client


class AsyncInternalClient:
    def __init__(self, *, client_wrapper: AsyncClientWrapper):
        self._raw_client = AsyncRawInternalClient(client_wrapper=client_wrapper)
        self.users = AsyncUsersClient(client_wrapper=client_wrapper)

        self.clusters = AsyncClustersClient(client_wrapper=client_wrapper)

        self.deployments = AsyncDeploymentsClient(client_wrapper=client_wrapper)

        self.applications = AsyncApplicationsClient(client_wrapper=client_wrapper)

        self.vcs = AsyncVcsClient(client_wrapper=client_wrapper)

        self.metrics = AsyncMetricsClient(client_wrapper=client_wrapper)

        self.artifact_versions = AsyncArtifactVersionsClient(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> AsyncRawInternalClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        AsyncRawInternalClient
        """
        return self._raw_client
